=== test/SConstruct ===
#!/usr/bin/env python

env = SConscript("../SConstruct")

# tweak this if you want to use different folders, or more folders, to store your source code in.
env.Append(CPPPATH=['src/'])
sources = Glob('src/*.cpp')

library = env.SharedLibrary(
    "bin/libgdexample.{}.{}.{}{}".format(
        env["platform"], env["target"], env["arch_suffix"], env["SHLIBSUFFIX"]
    ),
    source=sources,
)

Default(library)
